uniform sampler2D base_tex_unit; // zakladna textura

uniform vec4 horzTapOffs2;
uniform vec4 horzTapOffs3;

// prenasane udaje
in vec2 uv;
in vec2 Tap[4],TapNeg[3];

void main (void)
{
 // pomocne premenne
 vec4 s[7],Weights4;
 vec3 Weights3,ColorSum;
 float WeightSum;
 vec2 Tap2[3],TapNeg2[3];

 // prahy pre vypocet vah vzoriek
 const vec4 Thresh0=vec4(0.1,0.3,0.5,-0.01);
 const vec4 Thresh1=vec4(0.6,0.7,0.8,0.9);

 // vzorky Gausovho filtra
 s[0]=texture(base_tex_unit,Tap[0]);
 s[1]=texture(base_tex_unit,Tap[1]);
 s[2]=texture(base_tex_unit,Tap[2]);
 s[3]=texture(base_tex_unit,Tap[3]);
 s[4]=texture(base_tex_unit,TapNeg[0]);
 s[5]=texture(base_tex_unit,TapNeg[1]);
 s[6]=texture(base_tex_unit,TapNeg[2]);

 // vypocet vah pre 4 vnutorne vzorky v zavislosti od blur
 Weights4.x=clamp(s[1].a-Thresh0.x,0.0,1.0);
 Weights4.y=clamp(s[2].a-Thresh0.y,0.0,1.0);
 Weights4.z=clamp(s[3].a-Thresh0.x,0.0,1.0);
 Weights4.w=clamp(s[0].a-Thresh0.w,0.0,1.0);

 // scitanie vzoriek ohodnotenych ich vahami
 ColorSum=vec3(s[0]*Weights4.x+s[1]*Weights4.y+s[2]*Weights4.z+s[3]*Weights4.w);

 // scitanie vah vzoriek
 WeightSum=dot(Weights4,vec4(1.0));

 // vypocet vah pre 3 vonkajsie vzorky v zavislosti od blur
 Weights3.x=clamp(s[4].a-Thresh0.x,0.0,1.0);
 Weights3.y=clamp(s[5].a-Thresh0.y,0.0,1.0);
 Weights3.z=clamp(s[6].a-Thresh0.z,0.0,1.0);

 // pricitanie vzoriek ohodnotenych ich vahami
 ColorSum+=vec3(s[4]*Weights3.x+s[4]*Weights3.y+s[6]*Weights3.z);

 // pricitanie vah vzoriek
 WeightSum+=dot(Weights3,vec3(1.0));

 // vzorky Gausovho filtra
 Tap2[0]=Tap[0]+horzTapOffs2.xy;
 Tap2[1]=Tap[0]+horzTapOffs2.zw;
 Tap2[2]=Tap[0]+horzTapOffs3.xy;
 TapNeg2[0]=Tap[0]-horzTapOffs2.xy;
 TapNeg2[1]=Tap[0]-horzTapOffs2.zw;
 TapNeg2[2]=Tap[0]-horzTapOffs3.xy;
 s[0]=texture2D(base_tex_unit,Tap2[0]);
 s[1]=texture2D(base_tex_unit,Tap2[1]);
 s[2]=texture2D(base_tex_unit,Tap2[2]);
 s[3]=texture2D(base_tex_unit,TapNeg2[0]);
 s[4]=texture2D(base_tex_unit,TapNeg2[1]);
 s[5]=texture2D(base_tex_unit,TapNeg2[2]);

 // vypocet vah pre 3 vzorky v zavislosti od blur
 Weights3.x=clamp(s[0].a-Thresh1.x,0.0,1.0);
 Weights3.y=clamp(s[1].a-Thresh1.y,0.0,1.0);
 Weights3.z=clamp(s[2].a-Thresh1.z,0.0,1.0);
	
 // pricitanie vzoriek ohodnotenych ich vahami
 ColorSum+=vec3(s[0]*Weights3.x+s[1]*Weights3.y+s[2]*Weights3.z);

 // pricitanie vah vzoriek
 WeightSum+=dot(Weights3,vec3(1.0));

 // vypocet vah pre 3 vzorky v zavislosti od blur
 Weights3.x=clamp(s[3].a-Thresh1.x,0.0,1.0);
 Weights3.y=clamp(s[4].a-Thresh1.y,0.0,1.0);
 Weights3.z=clamp(s[5].a-Thresh1.z,0.0,1.0);

 // pricitanie vzoriek ohodnotenych ich vahami
 ColorSum+=vec3(s[3]*Weights3.x+s[4]*Weights3.y+s[5]*Weights3.z);

 // pricitanie vah vzoriek
 WeightSum+=dot(Weights3,vec3(1.0));

 // podiel 13 vzoriek (6+1+6) a ich vah
 ColorSum/=WeightSum;

 // ulozenie vzoriek a vah do textury
 gl_FragData[0]=vec4(ColorSum,WeightSum);
}
